---- DATA STRUCTURES ----
--[[
    PlaySound = 
    {
        scope = "",
        name = "",
        x = 0,
        y = 0,
        z = 0,
        onPlayer = false,
        playWhileInside = true,
        attractZombies = false,
        hearableAddMaxDistance = 2000
    }    
--]]

---- INITIALISATION CHECK ----

if not (Monkey_Utils:IsSingleplayer() or isServer() or isCoopHost()) then
    return;
end

---- IMPORTS ----
local Constants = require "SoundManager/Monkey_SoundManagerConstants";
local Monkey_Logger = require 'Logging/Monkey_Logger';

local Log = Monkey_Logger:new('Monkey_ServerSoundManager');

Log:LogInfo('Initialised Monkey_ServerSoundManager!');

---- SERVER COMMAND INTEGRATION ----

local function onServerCommand(scopeName, command, args)
	if scopeName ~= Constants.ServerSoundManagerScope then 
        return 
    end;

    if args == nil then
        return;
    end

    --Handle Command
    if command == Constants.PlaySoundCommand then
        --Send play sound command to every client
        Monkey_Cmd:SendCommand(Constants.ClientSoundManagerScope, Constants.PlaySoundCommand, args);
    end

    Log:LogInfo('Recieved ' .. scopeName .. '-' .. command .. ' command!');
end

local function onGameStart_initialise()
    Events.OnServerCommand.Add(onServerCommand);
end

Events.OnGameStart.Add(onGameStart_initialise);