local Monkey_Logger = ISBaseObject:derive("Monkey_Logger");

local PREFIX = '[Monkey Logger]'

function Monkey_Logger:LogInfo(msg)
    if not isDebugEnabled() and not isAdmin() then return; end

    print(PREFIX .. self.scope .. ' INFO: ' .. msg);
end

function Monkey_Logger:LogWarn(msg)
    if not isDebugEnabled() and not isAdmin() then return; end

    print(PREFIX .. self.scope .. ' WARN: ' .. msg);
end

function Monkey_Logger:LogError(msg)
    if not isDebugEnabled() and not isAdmin() then return; end

    print(PREFIX .. self.scope .. ' ERROR: ' .. msg);
end

function Monkey_Logger:new(scope)
    local o = {};
    setmetatable(o, self);
    self.__index = self;

    o.scope = '[' .. scope .. ']';

    return o;
end

return Monkey_Logger;

--[[
    --this would print log messages with the specified prefix
    --the example below will print out the following:
    --"[Monkey Logger]['luafile1'] INFO: abc"

    --Usage
    local Monkey_Logger = require 'Logging/Monkey_Logger';
    local Log = Monkey_Logger:new('luafile1');    
    Log:LogInfo('abc')
--]]