local Monkey_ModData = ISBaseObject:derive("Monkey_ModData");

-- todo use actual GlobalModData

function Monkey_ModData:GetMonkeyModData()
    local entity = self.entity or getGameTime();

    entity:getModData()[self.key] = entity:getModData()[self.key] or {};
    
    if self.subkey then
        entity:getModData()[self.key][self.subkey] = entity:getModData()[self.key][self.subkey] or {};
        return entity:getModData()[self.key][self.subkey];
    else
        return entity:getModData()[self.key];
    end
end

function Monkey_ModData:init(key, subkey)
    _G['Monkey_ModData'] = getGameTime():getModData();
    local o = {};
    setmetatable(o, self);
    self.__index = self;

    o.key = key;
    o.subkey = subkey;

    return o;
end

function Monkey_ModData:initEntityModData(entity, key, subkey)
    _G['Monkey_ModData'] = entity:getModData();
    local o = {};
    setmetatable(o, self);
    self.__index = self;

    o.key = key;
    o.subkey = subkey;
    o.entity = entity;

    return o;
end

return Monkey_ModData;

--[[
    --This would create modData in getTime():getModData()
    --With structure: getTime():getModData().modName.test1
    --You can then add items to test1.
    --Makes it easier to manage world mod data

    --Usage
    local Monkey_ModData = require 'ModDataManager/Monkey_ModData';
    local ModData = Monkey_ModData:init('modName', 'test1');
--]]