Monkey_Utils = {}

function Monkey_Utils:Data_AppendDataToTable(src, dest)
    for k,v in pairs(src) do 
        if v ~= nil then
            table.insert(dest, v);
        end
    end
end

function Monkey_Utils:Random_ProbabilityCheck(percentageTrue)
    local random = ZombRand(1,1000);
    return random <= percentageTrue * 10;
end

function Monkey_Utils:IsSingleplayer()
        return not isClient() and not isServer() and not isCoopHost();
end

function Monkey_Utils:IsOutside(player)
    return player:isOutside();
end

function Monkey_Utils:Lerp(firstFloat, secondFloat, by)
    return firstFloat * (1 - by) + secondFloat * by;
end

function Monkey_Utils:getDistanceBetweenXY(x1, y1, x2, y2)
	local dx = x1 - x2;
	local dy = y1 - y2;

	local val = math.sqrt ( dx * dx + dy * dy );

	return val
end

--[[
    data = {
        Value = 123,
        Deviation = 444
    }    
--]]

function Monkey_Utils:GetValueWithDeviation(data)
    if not data then
        return nil;
    end

    local dataVal = math.abs(data.Value);

    if data.Deviation then
        local deviation = math.abs(data.Deviation);
        if deviation > 0 then
            local rand = ZombRandFloat(0.0,deviation);
            if ZombRand(2) == 0 then
                rand = rand * -1;
            end

            dataVal = dataVal + rand;
        end
    end

    return math.ceil(dataVal);
end

function Monkey_Utils:Clamp(x, min, max)
    if x < min then
        return min;
    elseif x > max then
        return max;
    else 
        return x;
    end
end

function Monkey_Utils:GetDateTimeIdentifierString()    
    local temp = os.date("*t");
    return temp.year .. temp.month .. temp.day .. temp.hour .. temp.min .. temp.sec;
end