-- Courtesy of KONIJIMA's https://steamcommunity.com/sharedfiles/filedetails/?id=2834231099 --

local Monkey_Sound = ISBaseObject:derive("Monkey_Sound");

function Monkey_Sound:play(x, y, z, attractZombies)
    if isServer() then return; end

    local sound = self.sound;

    if sound and type(sound) == "table" then
        soundName = sound.name;
        range = sound.range or 0;
    end

    local emitter = getWorld():getFreeEmitter();
    if emitter then
        emitter:setPos(x, y, z);
        emitter:playSoundImpl(soundName, false, nil);
        if attractZombies and range > 0 then
            addSound(nil, x, y, z, range, range);
        end
    end
end

--[[
    sound = 
    {
        name = "",
        range = 1000,
    }
--]]
function Monkey_Sound:new(sound)
    local o = {};
    setmetatable(o, self);
    self.__index = self;

    o.sound = sound or {};

    return o;
end

return Monkey_Sound;
